local AddOnName, Engine, _ = ...
local AddOnShortName = "OHCB"
local LDB = LibStub("LibDataBroker-1.1")
local AddOn = LibStub("AceAddon-3.0"):NewAddon(AddOnName, "AceEvent-3.0")
local DataObjects = {}

Engine[1] = AddOn
Engine[2] = LDB
Broker_OrderHallCommandBar = Engine

AddOn.ShowBar = false

local UIParent_UpdateTopFramePositions_Orig = UIParent_UpdateTopFramePositions
function UIParent_UpdateTopFramePositions(...)
    if OrderHallCommandBar and OrderHallCommandBar:IsShown() and not AddOn.ShowBar then
        OrderHallCommandBar:Hide()
    end
    AddOn.ShowBar = false
    return UIParent_UpdateTopFramePositions_Orig(...)
end

local function RequestCategoryInfo()
    C_Garrison.RequestClassSpecCategoryInfo(LE_FOLLOWER_TYPE_GARRISON_7_0)
end

function AddOn:NewDataObject(type, name)
    local dataObject = LDB:NewDataObject(AddOnShortName .. " " .. name, {
        type = type, 
        label = name
    })
    tinsert(DataObjects, dataObject)
    return dataObject
end


function AddOn:OnInitialize()
    for _, dataObject in next, DataObjects do
        if dataObject.OnInitialize then 
            dataObject:OnInitialize() 
        end
        if dataObject.OnShowTooltip then
            dataObject.OnEnter = function (self)
                GameTooltip:SetOwner(self, "ANCHOR_NONE")
                GameTooltip:SetPoint("TOPLEFT", self, "BOTTOMLEFT")
                GameTooltip:ClearLines()
                dataObject.OnTooltipShow(GameTooltip)
                GameTooltip:Show()
            end
            dataObject.OnLeave = function () 
                GameTooltip:Hide()
            end
        end
    end

    self:RegisterEvent("PLAYER_ENTERING_WORLD", RequestCategoryInfo)
    self:RegisterEvent("UNIT_AURA", RequestCategoryInfo)
    self:RegisterEvent("GARRISON_TALENT_COMPLETE", RequestCategoryInfo)
    self:RegisterEvent("GARRISON_TALENT_UPDATE", RequestCategoryInfo)
    self:RegisterEvent("UNIT_PHASE", RequestCategoryInfo)

    RequestCategoryInfo()
end
