local BOHCB, LDB = unpack(Broker_OrderHallCommandBar)

local Troops = {
    "Lesser Troops",  -- 1
    "Greater Troops", -- 2
    "Special Troops",  -- 3
    "Powerful Troops", -- 4
    "Argus Troops" -- 5
}

local function TroopObject(id)
    local self = LibStub("AceEvent-3.0"):Embed(BOHCB:NewDataObject("data source", Troops[id]))

    local function Update()
        local categoryInfo = C_Garrison.GetClassSpecCategoryInfo(LE_FOLLOWER_TYPE_GARRISON_7_0)
        
        table.sort(categoryInfo, function(a, b) return a.classSpec < b.classSpec end);

        local category = categoryInfo[id]
        if category then
            self.icon = category.icon
            self.name = category.name
            self.text = category.name
            self.description = category.description
            if category.count and category.limit then
                self.text = format(ORDER_HALL_COMMANDBAR_CATEGORY_COUNT, category.count, category.limit)
            end
        end
    end

    function self:OnInitialize()
        self:RegisterEvent("PLAYER_ENTERING_WORLD", Update)
        self:RegisterEvent("UNIT_AURA", Update)
        self:RegisterEvent("GARRISON_FOLLOWER_CATEGORIES_UPDATED", Update)
        self:RegisterEvent("GARRISON_FOLLOWER_ADDED", Update)
        self:RegisterEvent("GARRISON_FOLLOWER_REMOVED", Update)

        Update()
    end

    function self.OnTooltipShow(tooltip)
        if self.name then
            tooltip:AddLine(self.name or LDB:GetNameByDataObject(self))
            if self.description then
                tooltip:AddLine(self.description, 1, 1, 1, true)
            end
        else
            tooltip:AddLine(LDB:GetNameByDataObject(self))
            tooltip:AddLine(UNAVAILABLE, 1.0, 0.1, 0.1, true)
        end
    end
end

local Troop1 = TroopObject(1) -- lesser
local Troop2 = TroopObject(2) -- greater
local Troop3 = TroopObject(3) -- special
local Troop4 = TroopObject(4) -- powerful
local Troop5 = TroopObject(5) -- argus
